#include <ESP32Servo.h>
#include <analogWrite.h>
#include <IRremoteESP8266.h>
#include <IRrecv.h>
#include <NewPing.h>
#include <BluetoothSerial.h>

BluetoothSerial bt;

//%PINES MOTORDC%//
int motorpin1=25;
int motorpin2=26;
int ENA=19;

int motorpin1B=12;
int motorpin2B=13;
int ENAB=18;


//%PINES SERVO%//
int servoPin=14;
Servo miservo;

//%PINES ULTRASONIC%//
#define TRIGGER_PIN 27
#define ECHO_PIN 16

NewPing sonar(TRIGGER_PIN, ECHO_PIN);

/*unsigned int readDistance() {
  unsigned int distance = sonar.ping_cm();
  return distance;
}*/


//%PINES IR%//
const uint16_t RECV_PIN = 5;  // Pin donde se conecta el receptor IR

IRrecv irrecv(RECV_PIN);
decode_results codigo;

const uint64_t codigoEncendido = 0xFFA25D;
const uint64_t evitaobs=0xFF30CF;
const uint64_t siguelines=0xFF18E7;
const uint64_t mandomode=0xFF7A85;

//%PINES TCRT5000%
const int sensorPin1 = 2;
const int sensorPin2 = 4;

int modo=0;
unsigned int distance;

void setup() {

  Serial.begin(9600);

  bt.begin("Cocherc");
  
  pinMode(motorpin1, OUTPUT);
  pinMode(motorpin2, OUTPUT);
  pinMode(ENA, OUTPUT);

  pinMode(motorpin1B, OUTPUT);
  pinMode(motorpin2B, OUTPUT);
  pinMode(ENAB, OUTPUT);

  miservo.attach(servoPin);
  miservo.write(90);

  irrecv.enableIRIn();  // Inicia el receptor IR

  pinMode(sensorPin1, INPUT);
  pinMode(sensorPin2, INPUT);
  pinMode(17, INPUT);

}

void loop() {

  int selec=digitalRead(17);

  if(selec==0){

  if (bt.available()) { // Comprobar si hay datos disponibles para leer

    int incomingData = bt.read(); // Leer el dato recibido

    Serial.print("Dato recibido: ");
    Serial.println(incomingData);

    if(incomingData==0||incomingData==10){

      moveForward(150);

    }
    if(incomingData==4||incomingData==6){

      stop();

    }
    if(incomingData==2||incomingData==7){

      turnRight(150,150);

    }
    if(incomingData==3||incomingData==8){

      turnLeft(150,150);

    }
    if(incomingData==1||incomingData==9){

      moveBackward(150);

    }
  }
  }

  if(selec==1){
  
  if (irrecv.decode(&codigo)) {  // Si se recibe una señal IR
    Serial.println(codigo.value, HEX);  // Muestra el valor hexadecimal de la señal recibida
    irrecv.resume();
  }
  delay(100);

  if(codigo.value==0xFF629D){moveForward(150);}
  if(codigo.value==0xFFC23D){turnRight(150,150);}
  if(codigo.value==0xFF22DD){turnLeft(150,150);}
  if(codigo.value==0xFFA857){moveBackward(150);}
  if(codigo.value==0xFF02FD){stop(); modo=0;}
  if(codigo.value==0xFF30CF){modo=1;}


  if(modo==1){

    distance=sonar.ping_cm();
    Serial.println(distance);

    if(distance<20){

      backObstacle(100,200);
      delay(300);
  
    }

    else{
    
      miservo.write(90);
      moveForward(150);
      delay(100);
    
    }
  }
  }
}

//%FUNCIONES%//
void moveForward(int velocidad){

  miservo.write(90);

  analogWrite(ENA, velocidad);
  digitalWrite(motorpin1, HIGH);
  digitalWrite(motorpin2, LOW);

  analogWrite(ENAB, velocidad);
  digitalWrite(motorpin1B, HIGH);
  digitalWrite(motorpin2B, LOW);

}
void moveBackward(int velocidad){

  miservo.write(90);

  analogWrite(ENA, velocidad);
  digitalWrite(motorpin1, LOW);
  digitalWrite(motorpin2, HIGH);

  analogWrite(ENAB, velocidad);
  digitalWrite(motorpin1B, LOW);
  digitalWrite(motorpin2B, HIGH);
  
}
void stop(){

  miservo.write(90);

  digitalWrite(motorpin1, LOW);
  digitalWrite(motorpin2, LOW);

  digitalWrite(motorpin1B, LOW);
  digitalWrite(motorpin2B, LOW);
  
}
void turnRight(int velocidad, int velocidadB){

  miservo.write(65);
  analogWrite(ENA, velocidad);
  digitalWrite(motorpin1, HIGH);
  digitalWrite(motorpin2, LOW);

  analogWrite(ENAB, velocidadB);
  digitalWrite(motorpin1B, HIGH);
  digitalWrite(motorpin2B, LOW);
  
}
void turnLeft(int velocidad, int velocidadB){

  miservo.write(115);
  analogWrite(ENA, velocidad);
  digitalWrite(motorpin1, HIGH);
  digitalWrite(motorpin2, LOW);

  analogWrite(ENAB, velocidadB);
  digitalWrite(motorpin1B, HIGH);
  digitalWrite(motorpin2B, LOW);
  
}
void backObstacle(int velocidad, int velocidadB){

  miservo.write(65);
  analogWrite(ENA, velocidad);
  digitalWrite(motorpin1, LOW);
  digitalWrite(motorpin2, HIGH);

  analogWrite(ENAB, velocidadB);
  digitalWrite(motorpin1B, LOW);
  digitalWrite(motorpin2B, HIGH);

  delay(500);

}
